set -o nounset -o pipefail -o errexit

rm -rf .libs test_child_common dummy_child.o *.log
mkdir -p .libs
gcc -Wall -Wextra -g -c dummy_child.c
gcc -Wall -Wextra -g dummy_child.o -o .libs/lt-dummy-child
gcc -Wall -Wextra -g test_child_common.c -o test_child_common
valgrind --leak-check=full \
         --log-file=test_child_common.%p.valgrind.log \
         --leak-check=full \
         --trace-children=yes \
         --trace-children-skip='*/bin/*,*/sbin/*' \
         --gen-suppressions=all \
         --verbose \
         ./test_child_common

ERRORS=`grep ERROR *.log | grep -v "0 errors" | wc -l || true`

if [ "$ERRORS" -ne 0 ]; then
    echo FAILED
    exit 1
else
    echo PASSED
fi
